前往小程序,Get更优阅读体验!
立即前往
首页
学习
活动
专区
工具
TVP
发布
社区首页 >专栏 >Leetcode 209 Minimum Size Subarray Sum

Leetcode 209 Minimum Size Subarray Sum

作者头像
triplebee
发布2018-01-12 14:43:56
5690
发布2018-01-12 14:43:56
举报
文章被收录于专栏:计算机视觉与深度学习基础

Given an array of n positive integers and a positive integer s, find the minimal length of a contiguous subarray of which the sum ≥ s. If there isn't one, return 0 instead.

For example, given the array [2,3,1,2,4,3] and s = 7, the subarray [4,3] has the minimal length under the problem constraint.

找到最小连续子数组,使得和大于等于给定值。

因为所有数都是正数,所以子数组的和满足单调性,两个点贪心扫一遍就可以了

代码语言:javascript
复制
class Solution {
public:
    int minSubArrayLen(int s, vector<int>& nums) {
        int res = 0, l = 0, r = 0;
        int ans = INT_MAX;
        while(r <= nums.size())
        {
            if(res >= s) 
            {
                ans = min(ans, r - l);
                res -= nums[l++];
            }
            else
            {
                if(r == nums.size()) break;
                res += nums[r++];
            }              
        }
        return ans == INT_MAX ? 0 : ans;
    }
};
本文参与 腾讯云自媒体同步曝光计划,分享自作者个人站点/博客。
原始发表:2017-03-18 ,如有侵权请联系 cloudcommunity@tencent.com 删除

本文分享自 作者个人站点/博客 前往查看

如有侵权,请联系 cloudcommunity@tencent.com 删除。

本文参与 腾讯云自媒体同步曝光计划  ,欢迎热爱写作的你一起参与!

评论
登录后参与评论
0 条评论
热度
最新
推荐阅读
领券
问题归档专栏文章快讯文章归档关键词归档开发者手册归档开发者手册 Section 归档